package database;

import global.GlobalData;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * Clase para crear las tablas que contendra la informacion geografica de GoodWave
 * */
public class TablaGeografia {

	/**
	 * Crea la tabla que contendra la informacion geografica  de GoodWave
	 * */
	public static void main/*TablaGeografia*/() throws InterruptedException {

		Connection conn = null;
	
		try
		{
			 //----------  CONEXION A LA BD  ----------------
			
	         Class.forName("com.mysql.jdbc.Driver");
	         
	         //TODO controlar acceso identificado
	         conn = DriverManager.getConnection(GlobalData.url,GlobalData.login,GlobalData.password);
	         //conn = DriverManager.getConnection(GlobalData.connectionURL);
	         if (conn == null)
	         {
	            System.out.println("Conexin a base de datos "+GlobalData.url+" ... falhida");
	         }
	         
	         //---  EJECUCION DE BORRADO Y CREACION DE TABLAS  -----
	         try{
	             Statement st = conn.createStatement();

	             //------  CREACION  -------------
	             st.executeUpdate("SET NAMES utf8");
	             //Create table geografia
	             String table = ("CREATE TABLE `geografia` (" +
	       			  "`LugarId` int(11) NOT NULL," +
	       			  "`Nombre` varchar(50) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL," + //latin1_general_ci para que se consideren diferentes: e y 
	       			  "`Nivel` varchar(40) NOT NULL," +
	       			  "PRIMARY KEY (LugarId, Nombre)" +
	       			  ")TYPE = INNODB");
	             st.executeUpdate(table);
		            
	             System.out.println("Creacion de la tabla 'geografia': OK");
	         }
	         	catch(SQLException s){
	         		System.out.println("No se ha podido crear la tabla \"geografia\"");
	         		System.out.println(s);
	         }
	         try{
	        	 Statement st = conn.createStatement();
	             //Create table jerarquia
	        	 String table = ("CREATE TABLE `jerarquia` (" +
		       			  "`LugarId` int(11) NOT NULL PRIMARY KEY," +
		       			  "`PerteneceA` int(11) NOT NULL," +
		       			  "FOREIGN KEY(LugarId) REFERENCES geografia(LugarId)," +
		       			  "FOREIGN KEY(PerteneceA) REFERENCES geografia(LugarId)" +
		       			  ") TYPE = INNODB");
		             st.executeUpdate(table);
	             
	             System.out.println("Creacion de la tabla 'jerarquia': OK");
		             
	           }
	           catch(SQLException s){
	        	   System.out.println("No se ha podido crear la tabla \"jerarquia\"");
	             System.out.println(s);
	         }
	
	         conn.close();
	         
	         //------- FIN CONEXION A LA BD  ----------------
	      }
		  catch(SQLException ex)
		  {
			 System.out.println("No se ha podido conectar con la Base de Datos");
		     System.out.println(ex);
		  }
		  catch(ClassNotFoundException ex)
		  {
		     System.out.println(ex);
		  }
	}
}
